package java.util.function;

import java.util.Objects;

@FunctionalInterface
public interface DoubleUnaryOperator
{
    public abstract double applyAsDouble(double p0);
    
    default public DoubleUnaryOperator compose(DoubleUnaryOperator obj) {
        Objects.requireNonNull(obj);
        return n2/* double, */ -> this.applyAsDouble(p0.applyAsDouble(n2));
    }
    
    default public DoubleUnaryOperator andThen(DoubleUnaryOperator obj) {
        Objects.requireNonNull(obj);
        return n2/* double, */ -> p0.applyAsDouble(this.applyAsDouble(n2));
    }
    
    public static DoubleUnaryOperator identity() {
        return n/* double, */ -> n;
    }
}
